Index: trunk/LATMOS-Accounts-Web/root/html/admin/requests/index.tt
===================================================================
--- trunk/LATMOS-Accounts-Web/root/html/admin/requests/index.tt	(revision 1126)
+++ trunk/LATMOS-Accounts-Web/root/html/admin/requests/index.tt	(revision 1127)
@@ -28,10 +28,13 @@
 [% IF oobject %]
 [% dsn = oobject.get_attributes('displayName') %]
-<a href="[% c.uri_for('/', c.forward('/obj_to_uri', [ oobject.type ]), oobject.id) %]">
 [% IF dsn %]
 [% dsn | truncate(20) | html %]
-([% oobject.id | html %])
+(<a href="[% c.uri_for('/', c.forward('/obj_to_uri', [ oobject.type ]), oobject.id) %]">
+[%- oobject.id | html -%]
+</a>)
 [%- ELSE -%]
-[% oobject.id | html %]
+<a href="[% c.uri_for('/', c.forward('/obj_to_uri', [ oobject.type ]), oobject.id) %]">
+[%- oobject.id | html -%]
+</a>
 [%- END -%]
 </a>
Index: trunk/LATMOS-Accounts-Web/root/html/includes/header.tt
===================================================================
--- trunk/LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 1126)
+++ trunk/LATMOS-Accounts-Web/root/html/includes/header.tt	(revision 1127)
@@ -36,15 +36,9 @@
 
 <h1 style="">
+    Gestion informatique
     [% IF c.config.company %]
-    Gestion informatique - [% c.config.company | html %]
-    [% ELSE %]
-    Gestion informatique
+    - [% c.config.company | html %]
     [% END %]
 </h1>
-
-<a href="[% c.uri_for('/users', c.user.username) %]">Ma page</a>
-::
-<a href="[% c.uri_for('/users', c.user.username, 'passwd') %]">Changer mon mot de passe</a>
-::
 
 </div><!-- #header -->
Index: trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt
===================================================================
--- trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt	(revision 1126)
+++ trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt	(revision 1127)
@@ -1,2 +1,28 @@
+<ul>
+<li>
+<a href="[% c.uri_for('/users', c.user.username) %]">Ma page</a>
+</li>
+<li><a href="[% c.uri_for('/users', c.user.username, 'passwd') %]">Changer mon mot
+de passe</a></li>
+</ul>
+
+
+[% FOREACH h = c.model('Accounts').db.search_objects('accreq', 'exported=*') %]
+[% o = c.model('Accounts').db.get_object('accreq', h) %]
+[% IF loop.first %]
+<ul>
+[% END %]
+[% IF NOT o.get_attributes('hidden') %]
+<li>
+<a href="[% c.uri_for('/request', h) %]">
+[% o.get_attributes('description') || o.id | html %]
+</a>
+</li>
+[% END %]
+[% IF loop.last %]
+</ul>
+[% END %]
+[% END %]
+
 [% reqlist = \c.model('Accounts').db.list_requests %]
 [% reqlistdue = \c.model('Accounts').db.list_requests(1) %]
@@ -10,29 +36,13 @@
 [% END %]
 <li>
-<a href="[% c.uri_for('/admin', 'requests') %]">[% reqlist.size %] requÃªtes</a>
+<a href="[% c.uri_for('/admin', 'requests') %]">[% reqlist.size %] requÃªtes...</a>
 </li>
 </ul>
 [% END %]
 
+<ul>
+<li><a href="[% c.uri_for('/admin')
+%]">Gestion...</a></li>
+</li>
+</ul>
 
-
-[% FOREACH h = c.model('Accounts').db.search_objects('accreq', 'exported=*') %]
-[% o = c.model('Accounts').db.get_object('accreq', h) %]
-[% NEXT IF o.get_attributes('hidden') %]
-[% IF loop.first %]
-<h3>Formuler une demande:</h3>
-<ul>
-[% END %]
-<li>
-<a href="[% c.uri_for('/request', h) %]">
-[% o.get_attributes('description') || o.id | html %]
-</a>
-</li>
-[% IF loop.last %]
-</ul>
-[% END %]
-[% END %]
-
-<h3><a href="[% c.uri_for('/admin')
-%]">Administration...</a></li>
-</h3>
Index: trunk/LATMOS-Accounts-Web/root/static/style.css
===================================================================
--- trunk/LATMOS-Accounts-Web/root/static/style.css	(revision 1126)
+++ trunk/LATMOS-Accounts-Web/root/static/style.css	(revision 1127)
@@ -219,16 +219,13 @@
 
 #sidebar {
-    background-color: #4e8fbb;
+/*    background-color: #4e8fbb; */
     border: solid;
     border-color: #437ba1;
 }
 
-#sidebar h3 {
-    font-size: 0.8em;
-}
-
 #sidebar ul {
     list-style-type: none;
-    padding: 0em;
+    padding-top: 0.2em;
+    padding-left: 0em;
 }
 
@@ -237,5 +234,18 @@
 }
 
-#header  {
-    background-color: #7DB4D8;
-}
+#sidebar a:hover {
+    background-color: #7DB4D8;
+}
+
+#header {
+    padding: 1px;
+}
+
+
+#header h1 {
+    text-align: center;
+    font-size: 1.2em;
+    margin: 0px;
+    padding: 0em;
+    background-color: #7DB4D8;
+}