Index: branches/4.0/LATMOS-Accounts/bin/la-sql-log
===================================================================
--- branches/4.0/LATMOS-Accounts/bin/la-sql-log	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/bin/la-sql-log	(revision 1299)
@@ -56,9 +56,10 @@
 
 foreach(@logs) {
-    printf("%s %s: %d / %s %s\n",
+    printf("%s %s: %s/%s (%d) %s\n",
         $_->{logdate},
         $_->{username},
+        $_->{otype},
+        $_->{name},
         $_->{ikey},
-        $_->{name},
         $_->{message},
     );
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts.pm	(revision 1299)
@@ -11,5 +11,5 @@
 use LATMOS::Accounts::Acls;
 
-our $VERSION = '4.0.6';
+our $VERSION = '4.0.7';
 
 =head1 NAME
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases.pm	(revision 1299)
@@ -447,14 +447,16 @@
         $data{$attribute->iname} = $cdata{$cfield};
     }
-    #keys %data or return 0; # TODO: return an error ?
-    my $obj = $self->create_object($otype, $id, %data) or return;
+    $self->create_object($otype, $id, %data) or return;
+    my $obj = $self->get_object($otype, $id) or return;
     $obj->ReportChange('Create', 'Object created with %s', join(', ', sort keys %cdata));
 
     foreach my $attrname (keys %data) {
         my $attribute = $self->attribute($obj->type, $attrname) or next;
+        $attribute->monitored or next;
+
         $obj->ReportChange('Attributes', '%s set to %s', $attrname,
             (ref $data{$attrname}
                 ? join(', ', @{ $data{$attrname} })
-                : $data{$attrname}) || '(none)') if ($attribute->{notify});
+                : $data{$attrname}) || '(none)');
     }
 
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Attributes.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Attributes.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Attributes.pm	(revision 1299)
@@ -397,4 +397,21 @@
 }
 
+=head2 monitored
+
+Return true if the attribute is monitored
+
+=cut
+
+sub monitored {
+    my ($self) = @_;
+
+    if ($self->iname ne $self->name) {
+        my $attr = $self->base->attribute($self->otype, $self->iname) or return;
+        return $attr->monitored;
+    } else {
+        return $self->{monitored} || 0;
+    }
+}
+
 1;
 
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Objects.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Objects.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Objects.pm	(revision 1299)
@@ -392,5 +392,5 @@
         };
         if ($attribute->set($cdata{$cfield})) {
-            $updated{$cfield} = $attribute->{notify};
+            $updated{$cfield} = $attribute->monitored;
         }
     }
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm	(revision 1299)
@@ -33,5 +33,5 @@
                 mandatory => 1,
                 multiple => 1,
-                notify => 1,
+                monitored => 1,
             },
             finalpoint      => { ro => 1, multiple => 1 },
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm	(revision 1299)
@@ -36,5 +36,5 @@
             date       => { inline => 1, ro => 1 },
             memberUID  => {
-                notify => 1,
+                monitored => 1,
                 hide => 1,
                 reference => 'user',
@@ -49,5 +49,5 @@
             },
             member     => {
-                notify => 1,
+                monitored => 1,
                 reference => 'user',
                 multiple => 1, 
@@ -64,5 +64,5 @@
             groupname  => { ro => 1 },
             managedBy  => {
-                notify => 1,
+                monitored => 1,
                 reference => 'user',
                 can_values => sub {
@@ -74,5 +74,5 @@
             },
             managedAlsoBy  => {
-                notify => 1,
+                monitored => 1,
                 reference => 'user',
                 multiple => 1,
@@ -87,5 +87,5 @@
             sutype => {
                 reference => 'sutype',
-                notify => 1,
+                monitored => 1,
             },
             autoMemberFilter => {
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm	(revision 1299)
@@ -32,5 +32,5 @@
             create  => { ro => 1, inline => 1, },
             ip      => {
-                notify => 1,
+                monitored => 1,
                 multiple => 1,
                 uniq => 1,
@@ -49,5 +49,5 @@
             },
             macaddr => {
-                notify => 1,
+                monitored => 1,
                 multiple => 1,
                 uniq => 1,
@@ -58,10 +58,10 @@
             },
             cname   => {
-                notify => 1,
+                monitored => 1,
                 multiple => 1, uniq => 1,
                 input => sub { lc($_[0]) } 
             },
             owner   => {
-                notify => 1,
+                monitored => 1,
                 reference => 'user',
                 delayed => 1,
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Netzone.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Netzone.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Netzone.pm	(revision 1299)
@@ -34,6 +34,6 @@
             date    => { ro => 1, inline => 1, },
             create  => { ro => 1, inline => 1, },
-            net     => { multiple => 1, notify => 1, },
-            netExclude => { multiple => 1, notify => 1, },
+            net     => { multiple => 1, monitored => 1, },
+            netExclude => { multiple => 1, monitored => 1, },
             group   => { hide => 1 },
             allow_dyn => {
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm	(revision 1299)
@@ -51,9 +51,7 @@
                 mandatory => 1,
                 formopts => { length => 7 },
-                notify => 1,
-            },
-            uidnumber => { inline => 1, hide => 1, },
+            },
+            uidnumber => { inline => 1, hide => 1, monitored => 1 },
             gidNumber => {
-                notify => 1,
                 inline => 1,
                 iname => 'gidnumber',
@@ -81,16 +79,17 @@
                 mandatory => 1,
                 reference => 'group',
+                monitored => 1,
             },
             exported  => {
                 inline => 1,
                 formtype => 'CHECKBOX',
-                notify => 1,
+                monitored => 1,
             },
             locked    => {
                 formtype => 'CHECKBOX',
                 formopts => { rawvalue => 1, },
-                notify => 1,
-            },
-            expire    => { inline => 1, formtype => 'DATE', notify => 1, },
+                monitored => 1,
+            },
+            expire    => { inline => 1, formtype => 'DATE', monitored => 1, },
             name      => { inline => 1, ro => 1, },
             cn        => {
@@ -148,5 +147,5 @@
                 },
                 reference => 'user',
-                notify => 1,
+                monitored => 1,
             },
             department => {
@@ -155,5 +154,5 @@
                     $base->search_objects('group', 'sutype=dpmt')
                 },
-                notify => 1,
+                monitored => 1,
             },
             contratType => {
@@ -162,5 +161,5 @@
                     $base->search_objects('group', 'sutype=contrattype')
                 },
-                notify => 1,
+                monitored => 1,
             },
             site => {
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm	(revision 1299)
@@ -101,5 +101,5 @@
         }
     }
-    $info->{exported}   = { inline => 1, formtype => 'CHECKBOX', hide => 1, notify => 1 };
+    $info->{exported}   = { inline => 1, formtype => 'CHECKBOX', hide => 1, monitored => 1 };
     $info->{unexported} = { inline => 1, formtype => 'CHECKBOX', };
 
Index: branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Unix.pm
===================================================================
--- branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Unix.pm	(revision 1295)
+++ branches/4.0/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Unix.pm	(revision 1299)
@@ -366,5 +366,5 @@
     };
     my $obj = $self->get_object($otype, $id) or return;
-    $obj->set_fields(%data);
+    $obj->set_fields(%data) or return;
     $obj
 }