Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Address.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Address.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Address.pm	(revision 1550)
@@ -48,9 +48,12 @@
             name =>         { inline => 1, },
             exported =>     { inline => 1, },
-            user =>         { inline => 1,
+            user =>         {
+                inline => 1,
                 reference => 'user',
+                label => l('User'),
             },
             site =>         {
                 reference => 'site',
+                label => l('Site'),
             },
             sn =>           {
@@ -64,4 +67,5 @@
                     return $user->_get_c_field($attr->name);
                 },
+                label => l('Last name'),
             },
             mail =>         {
@@ -75,4 +79,5 @@
                     return $user->_get_c_field($attr->name);
                 },
+                label => l('Email'),
             },
             givenName => {
@@ -86,4 +91,5 @@
                     return $user->_get_c_field($attr->name);
                 },
+                label => l('First name'),
             },
             postalAddress => {
@@ -108,4 +114,5 @@
                     );
                 },
+                label => l('Postal address'),
             },
             displayName =>  {
@@ -120,4 +127,5 @@
                     );
                 },
+                label => l('Name'),
             },
             co => {
@@ -141,4 +149,5 @@
                     }
                 },
+                label => l('Country'),
             },
             l => {
@@ -162,4 +171,5 @@
                     }
                 },
+                label => l('City'),
             },
             postalCode =>   {
@@ -183,4 +193,5 @@
                     }
                 },
+                label => l('Postal code'),
             },
             streetAddress => {
@@ -205,4 +216,5 @@
                     }
                 },
+                label => l('Street'),
             },
             postOfficeBox => {
@@ -226,4 +238,5 @@
                     }
                 },
+                label => l('Post office box'),
             },
             st => {
@@ -247,4 +260,5 @@
                     }
                 },
+                label => l('Street'),
             },
             facsimileTelephoneNumber => {
@@ -268,4 +282,5 @@
                     }
                 },
+                label => l('Fax number'),
             },
             o =>            {
@@ -289,13 +304,23 @@
                     }
                 },
-            },
-            isMainAddress => { formtype => 'CHECKBOX', },
+                label => l('o'),
+            },
+            isMainAddress => {
+                formtype => 'CHECKBOX',
+                label => l('Main address'),
+            },
             active => { ro => 1 },
-            telephoneNumber => { },
-            physicalDeliveryOfficeName => { },
+            telephoneNumber => {
+                label => l('Phone number'),
+            },
+            physicalDeliveryOfficeName => {
+                label => l('Office'),
+            },
             otherTelephone => { },
             ipPhone => { },
             homePhone => { },
-            description => { },
+            description => {
+                label => l('Description'),
+            },
         }
     );
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Aliases.pm	(revision 1550)
@@ -66,4 +66,5 @@
             },
             forward         => {
+                label => l('Forward'),
                 mandatory => 1,
                 multiple => 1,
@@ -114,8 +115,10 @@
                     return @res ? \@res : undef;
                 },
+                label => l('Final recipient')
             },
             parents         => {
                 ro => 1,
                 get => $recurs,
+                label => l('Parents')
             },
             anyparents      => {
@@ -137,10 +140,14 @@
                 reference => 'user',
                 multiple => 1,
+                label => l('User'),
             },
             expire    => {
                 inline => 1,
                 formtype => 'DATE',
-            },
-            comment => { },
+                label => l('Expire'),
+            },
+            comment => {
+                label => l('Comment'),
+            },
             autoMemberFilter => {
                 multiple => 1,
@@ -150,10 +157,11 @@
                     $self->object->populate_dyn_aliases;
                     return 1;
-                }
-
+                },
+                label => l('Automate filter'),
             },
             autoExclude => {
                 multiple => 1,
                 reference => 'user',
+                label => l('User excluded'),
             },
         }
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Employment.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Employment.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Employment.pm	(revision 1550)
@@ -52,10 +52,14 @@
         user =>         { inline => 1,
             reference => 'user',
-        },
-        description => { },
+            label => l('User'),
+        },
+        description => {
+            label => l('Description'),
+        },
         firstday => {
             inline => 1,
             formtype => 'DATE',
             monitored => 1,
+            label => l('First day'),
         },
         lastday => {
@@ -63,4 +67,5 @@
             formtype => 'DATE',
             monitored => 1,
+            label => l('Last day'),
         },
         'state' => {
@@ -81,4 +86,5 @@
                 }
             },
+            label => l('State'),
         },
         contratType => {
@@ -88,4 +94,5 @@
             },
             monitored => 1,
+            label => l('Type of contract'),
         },
         managerContact => {
@@ -98,4 +105,5 @@
             },
             reference => 'user',
+            label => l('Contact'),
         },
         department => {
@@ -105,7 +113,14 @@
             },
             monitored => 1,
-        },
-        company => { },
-        endcircuit    => { formtype => 'DATE', monitored => 1, },
+            label => l('Department'),
+        },
+        company => {
+            label => l('Company'),
+        },
+        endcircuit    => {
+            formtype => 'DATE',
+            monitored => 1,
+            label => l('End of entrance'),
+        },
         previous => {
             ro => 1,
@@ -126,4 +141,5 @@
                 return $res->{name};
             },
+            label => l('Previous'),
         },
         next => {
@@ -145,4 +161,5 @@
                 return $res->{name};
             },
+            label => l('Next'),
         },
         minFirstDay => {
@@ -182,4 +199,5 @@
                 }
             },
+            label => l('Minimal first day'),
         },
         maxLastDay => {
@@ -222,4 +240,5 @@
                 }
             },
+            label => l('Maximal last day'),
         },
     };
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Group.pm	(revision 1550)
@@ -32,4 +32,5 @@
                 iname => 'gidnumber',
                 mandatory => 1, 
+                label => l('GID'),
             },
             gidnumber  => { inline => 1, uniq => 1, hide => 1, },
@@ -69,4 +70,5 @@
                     $self->object->_set_group_members($data);
                 },
+                label => l('Member'),
             },
             member     => {
@@ -90,4 +92,5 @@
                     $self->object->_set_group_members($data);
                 },
+                label => l('Member'),
             },
             sAMAccountName => { iname => 'name', ro => 1 },
@@ -102,4 +105,5 @@
                     sort keys %uniq;
                 },
+                label => l('Manager'),
             },
             managedAlsoBy  => {
@@ -114,8 +118,10 @@
                     sort keys %uniq;
                 },
+                label => l('Secondary Manager'),
             },
             sutype => {
                 reference => 'sutype',
                 monitored => 1,
+                label => l('Structure'),
             },
             autoMemberFilter => {
@@ -126,10 +132,19 @@
                     $self->object->populate_dyn_group;
                     return 1;
-                }
-            },
-            label => { },
-            expire => { },
-            description => { },
-            comment => { },
+                },
+                label => l('Automatics filters'),
+            },
+            label => {
+                label => l('Label'),
+            },
+            expire => {
+                label => l('Expire'),
+            },
+            description => {
+                label => l('Description'),
+            },
+            comment => {
+                label => l('Comment'),
+            },
             memberCount => {
                 managed => 1,
@@ -138,5 +153,6 @@
                     my ($self) = @_;
                     scalar(@{$self->object->_get_c_field('memberUID')});
-                }
+                },
+                label => l('Member count'),
             },
         }
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Nethost.pm	(revision 1550)
@@ -52,5 +52,6 @@
                         return undef;
                     };
-                }
+                },
+                label => l('Ip'),
             },
             ipFrom  => {
@@ -76,4 +77,5 @@
                     return $count;
                 },
+                label => l('Ip from...'),
             },
             macaddr => {
@@ -90,13 +92,16 @@
                     return $_[0] =~ /^([0-9a-f]{2}([:-]|$)){6}$/i ? 1 : undef;
                 },
+                label => l('Hardware address'),
             },
             cname   => {
                 monitored => 1,
                 multiple => 1,
-                input => sub { lc($_[0]) } 
+                input => sub { lc($_[0]) },
+                label => l('Aliases'),
             },
             related   => {
                 multiple => 1, uniq => 1,
                 reference => 'nethost',
+                label => l('Related'),
             },
             owner   => {
@@ -104,8 +109,10 @@
                 reference => 'user',
                 delayed => 1,
+                label => l('Owner'),
             },
             user    => {
                 reference => 'user',
                 delayed => 1,
+                label => l('User'),
             },
             netZone => {
@@ -139,5 +146,9 @@
                 },
             },
-            puppetClass => { multiple => 1, },
+            label => l('NetZones'),
+            puppetClass => {
+                multiple => 1,
+                label => l('Puppet Class'),
+            },
             netZoneExclude => {
                 multiple => 1, ro => 1, managed => 1,
@@ -169,10 +180,16 @@
             },
             exported => { formtype => 'CHECKBOX', },
-            noInheritPuppet => { formtype => 'CHECKBOX', },
+            noInheritPuppet => {
+                formtype => 'CHECKBOX',
+            },
             otherName => {
                 multiple => 1,
                 input => sub { lc($_[0]) },
-            },
-            sshfp => { multiple => 1, },
+                label => l('Other name'),
+            },
+            sshfp => {
+                multiple => 1,
+                label => l('SSH finger print'),
+            },
             ip6 => { },
             sshfpUpdate  => {
@@ -197,9 +214,19 @@
                 }
             },
-            comment => { },
-            description => { },
-            encryptKey => { },
-            reverse => { },
-            serialNumber => { },
+            comment => {
+                label => l('Comment'),
+            },
+            description => {
+                label => l('Description'),
+            },
+            encryptKey => {
+                label => l('Encrypted key'),
+            },
+            reverse => {
+                label => l('Reverse name'),
+            },
+            serialNumber => {
+                label => l('Serial number'),
+            },
         }
     )
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Service.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Service.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/Service.pm	(revision 1550)
@@ -33,6 +33,12 @@
             date   => { ro => 1, inline => 1, },
             create => { ro => 1, inline => 1, },
-            start  => { inline => 1, formtype => 'DATE', },
-            end    => { inline => 1, formtype => 'DATE', },
+            start  => {
+                inline => 1, formtype => 'DATE',
+                label => l('Start'),
+            },
+            end    => {
+                inline => 1, formtype => 'DATE',
+                label => l('End'),
+            },
             type   => { },
 
@@ -53,11 +59,17 @@
                     return @res;
                 },
+                label => l('Depend on'),
             },
             manager => {
                 multiple => 1,
                 reference => 'user',
+                label => l('Manager'),
             },
-            comment => { },
-            description => { },
+            comment => {
+                label => l('Comment'),
+            },
+            description => {
+                label => l('Description'),
+            },
         }
     )
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/User.pm	(revision 1550)
@@ -129,4 +129,5 @@
                 mandatory => 1,
                 formopts => { length => 7 },
+                label => l('UID'),
             },
             uidnumber => { inline => 1, hide => 1, monitored => 1 },
@@ -167,6 +168,10 @@
                 },
                 reference => 'group',
-            },
-            loginShell => { mandatory => 1 },
+                label => l('GID'),
+            },
+            loginShell => {
+                mandatory => 1
+                label => l('Shell'),
+            },
             gidnumber => { inline => 1, hide => 1,
                 can_values => sub {
@@ -195,5 +200,5 @@
                 formopts => { rawvalue => 1, },
                 monitored => 1,
-                label => sub { l('Locked') },
+                label => l('Locked'),
             },
             expire        => {
@@ -201,4 +206,5 @@
                 formtype => 'DATETIME',
                 monitored => 1,
+                label => l('Expire'),
             },
             endcircuit    => {
@@ -206,4 +212,5 @@
                 formtype => 'DATE',
                 monitored => 1,
+                label => l('End of entrance'),
             },
             endEmployment => {
@@ -216,4 +223,5 @@
                     $self->_computeEndEmployment($self->base->config('employment_delay'));
                 },
+                label => l('End of employment'),
             },
             endStrictEmployment => {
@@ -283,4 +291,5 @@
                     return $end ? $end->iso8601 : undef
                 },
+                label => l('End of any employment'),
             },
             cn        => {
@@ -350,4 +359,5 @@
                     return $res;
                 },
+                label => l('Member of'),
             },
             forward => {
@@ -390,4 +400,5 @@
                     return;
                 },
+                label => l('Forward'),
             },
             aliases   => {
@@ -443,4 +454,5 @@
                     $res
                 },
+                label => l('Aliases'),
             },
             revaliases => {
@@ -495,5 +507,4 @@
             },
             manager => {
-                label => l('Manager'),
                 reference => 'user',
                 ro => 1,
@@ -509,4 +520,5 @@
                     }
                 },
+                label => l('Responsible'),
             },
             department => {
@@ -516,4 +528,5 @@
                 },
                 monitored => 1,
+                label => l('Department'),
             },
             contratType => {
@@ -523,4 +536,5 @@
                 },
                 monitored => 1,
+                label => l('Type of contract'),
             },
             site => {
@@ -539,4 +553,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Site'),
             },
             co => {
@@ -563,4 +578,5 @@
                 },
                 set => $subsetaddress,
+                label => l('City'),
             },
             postalCode => {
@@ -575,4 +591,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Postal code'),
             },
             streetAddress => {
@@ -588,4 +605,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Street'),
             },
             postOfficeBox => {
@@ -600,4 +618,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Post office box'),
             },
             st => {
@@ -624,10 +643,16 @@
                 },
                 set => $subsetaddress,
+                label => l('Fax number'),
             },
             o => {
                 ro => 1,
                 iname => 'company',
-            },
-            ou => { iname => 'department', ro => 1 },
+                label => l('Company'),
+            },
+            ou => {
+                iname => 'department',
+                ro => 1,
+                label => l('Department'),
+            },
             telephoneNumber => {
                 get => sub {
@@ -641,4 +666,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Phone number'),
             },
             physicalDeliveryOfficeName => {
@@ -653,4 +679,5 @@
                 },
                 set => $subsetaddress,
+                label => l('Office'),
             },
             uid => { iname => 'name', ro => 1 },
@@ -675,4 +702,5 @@
                     return to_ascii($gecos);
                 },
+                label => l('GECOS'),
             },
             displayName  => {
@@ -689,4 +717,5 @@
                     || $self->object->id;
                 },
+                label => l('Name'),
             },
             sAMAccountName  => {
@@ -828,6 +857,10 @@
                     }
                 },
-            },
-            facsimileTelephoneNumber => { ro => 1, },
+                label => l('Postal Address'),
+            },
+            facsimileTelephoneNumber => {
+                ro => 1,
+                label => l('Fax number'),
+            },
             allsite   => {
                 ro => 1,
@@ -845,4 +878,5 @@
                 monitored => 1,
                 iname => 'manager',
+                label => l('Manager'),
             },
             expireText => {
@@ -892,8 +926,15 @@
                 delayed => 1,
                 ro => 1,
+                label => l('Departments'),
             },
             arrivalDate => { },
-            expired => { ro => 1 },
-            active => { ro => 1 },
+            expired => {
+                ro => 1
+                label => l('Expired'),
+            },
+            active => {
+                ro => 1
+                label => l('Active'),
+            },
             pwdAccountLockedTime => {
                 managed => 1,
@@ -921,9 +962,17 @@
             },
             userPassword => { readable => 0, },
-            wWWHomePage => { },
+            wWWHomePage => {
+                label => l('Web Page'),
+            },
             title => { },
-            snNative => { },
-            givenNameNative => { },
-            sn => { },
+            snNative => {
+                label => l('Native name'),
+            },
+            givenNameNative => {
+                label => l('Native first name'),
+            },
+            sn => {
+                label => l('Name'),
+            },
             shadowWarning => { },
             shadowMin => { },
@@ -935,21 +984,36 @@
             nickname => { },
             mobile => { },
-            mail => { },
+            mail => {
+                label => l('Email'),
+            },
             labeledURI => { },
             jobType => { },
             ipPhone => { },
-            initials => { },
+            initials => {
+                label => l('Initials'),
+            },
             homePhone => { },
-            homeDirectory => { },
+            homeDirectory => {
+                label => l('Home directory'),
+            },
             halReference => { },
             grade => { },
-            givenName => { },
+            givenName => {
+                label => l('first name'),
+            },
             encryptedPassword => { },
-            description => { },
-            company => { },
-            comment => { },
+            description => {
+                label => l('Description'),
+            },
+            company => {
+                label => l('Company'),
+            },
+            comment => {
+                label => l('Comment'),
+            },
             college => { },
             passwordLastSet => {
                 ro => 1,
+                label => l('Password set'),
             },
             currentEmployment => {
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/Bases/Sql/objects.pm	(revision 1550)
@@ -86,7 +86,19 @@
     # Common to all object attribute:
     my %commons = (
-        name      => { inline => 1, ro => 1, },
-        create    => { inline => 1, ro => 1, },
-        date      => { inline => 1, ro => 1, },
+        name      => {
+            inline => 1,
+            ro => 1,
+            label => l('Name'),
+        },
+        create    => {
+            inline => 1,
+            ro => 1,
+            label => l('Created'),
+        },
+        date      => {
+            inline => 1,
+            ro => 1,
+            label => l('Last modified'),
+        },
         exported   =>   { inline => 1, formtype => 'CHECKBOX', hide => 1, monitored => 1 },
         unexported =>   {
@@ -102,8 +114,24 @@
                 $self->object->_set_c_fields('exported', $data ? 0 : 1);
             },
+            label => l('Hidden'),
         },
-        services   =>   { managed => 1,  multiple => 1, reference => 'service' },
-        modifiedby =>   { inline  => 1, reference => 'user', ro => 1 },
-        createdby =>    { inline  => 1, reference => 'user', ro => 1 },
+        services   =>   {
+            managed => 1,
+            multiple => 1,
+            reference => 'service',
+            label => l('Service'),
+        },
+        modifiedby =>   {
+            inline  => 1,
+            reference => 'user',
+            ro => 1,
+            label => l('Modified by'),
+        },
+        createdby => {
+            inline  => 1,
+            reference => 'user',
+            ro => 1,
+            label => l('Created by'),
+        },
     );
 
Index: trunk/LATMOS-Accounts/lib/LATMOS/Accounts/I18N.pm
===================================================================
--- trunk/LATMOS-Accounts/lib/LATMOS/Accounts/I18N.pm	(revision 1549)
+++ trunk/LATMOS-Accounts/lib/LATMOS/Accounts/I18N.pm	(revision 1550)
@@ -25,5 +25,4 @@
 
 if (!$init) {
-    #POSIX::setlocale(POSIX::LC_ALL(), "");
     if (-d 'po') {
         Locale::gettext::bindtextdomain('linkaccounts', 'po')