Index: /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/About.pm
===================================================================
--- /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/About.pm	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/About.pm	(revision 1692)
@@ -3,4 +3,9 @@
 use warnings;
 use base 'Catalyst::Controller';
+
+use POSIX;
+use DateTime;
+use Date::Calc;
+use Date::Parse;
 
 =head1 NAME
@@ -25,4 +30,40 @@
 
     $c->stash->{page}{title} = "A propos...";
+
+    if ($c->user) {
+        my $ouser = $c->model('Accounts')->db->get_object(
+            'user',
+            $c->user->{username},
+        );
+
+        my @cd = split('-', DateTime->from_epoch(
+            epoch => str2time(
+                $ouser->get_attributes('create'),
+            )
+        )->ymd('-'));
+        my @now = split('-', DateTime->now()->ymd('-'));
+
+        my ($Dy,$Dm,$Dd) = Date::Calc::N_Delta_YMD(@cd, @now);
+        $c->stash->{accountExists} = join(', ',
+            ($Dy ? $c->loc('[_1] years', $Dy)  : ()),
+            ($Dm ? $c->loc('[_1] months', $Dm) : ()),
+            ($Dd ? $c->loc('[_1] days', $Dd)   : ()),
+        );
+
+        if (my $expire = $ouser->get_attributes('expire')) {
+            my @ed = split('-', DateTime->from_epoch(
+                epoch => str2time(
+                    $expire
+                )
+            )->ymd('-'));
+
+            my ($Dy,$Dm,$Dd) = Date::Calc::N_Delta_YMD(@now, @ed);
+            $c->stash->{accountExpire} = join(', ',
+                ($Dy ? $c->loc('[_1] years', $Dy)  : ()),
+                ($Dm ? $c->loc('[_1] months', $Dm) : ()),
+                ($Dd ? $c->loc('[_1] days', $Dd)   : ()),
+            );
+        }
+    }
 }
 
Index: /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Root.pm
===================================================================
--- /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Root.pm	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/Controller/Root.pm	(revision 1692)
@@ -74,37 +74,7 @@
 
     if ($c->user) {
-        my $ouser = $c->model('Accounts')->db->get_object(
-            'user',
-            $c->user->{username},
-        );
-
-        my @cd = split('-', DateTime->from_epoch(
-            epoch => str2time(
-                $ouser->get_attributes('create'),
-            )
-        )->ymd('-'));
-        my @now = split('-', DateTime->now()->ymd('-'));
-
-        my ($Dy,$Dm,$Dd) = Date::Calc::N_Delta_YMD(@cd, @now);
-        $c->stash->{accountExists} = join(', ',
-            ($Dy ? $c->loc('[_1] years', $Dy)  : ()),
-            ($Dm ? $c->loc('[_1] months', $Dm) : ()),
-            ($Dd ? $c->loc('[_1] days', $Dd)   : ()),
-        );
-
-        if (my $expire = $ouser->get_attributes('expire')) {
-            my @ed = split('-', DateTime->from_epoch(
-                epoch => str2time(
-                    $expire
-                )
-            )->ymd('-'));
-
-            my ($Dy,$Dm,$Dd) = Date::Calc::N_Delta_YMD(@now, @ed);
-            $c->stash->{accountExpire} = join(', ',
-                ($Dy ? $c->loc('[_1] years', $Dy)  : ()),
-                ($Dm ? $c->loc('[_1] months', $Dm) : ()),
-                ($Dd ? $c->loc('[_1] days', $Dd)   : ()),
-            );
-        }
+        $c->res->redirect(
+            $c->uri_for('/users', $c->user->{username})
+        )
     }
 }
Index: /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/I18N/fr.po
===================================================================
--- /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/I18N/fr.po	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/lib/LATMOS/Accounts/Web/I18N/fr.po	(revision 1692)
@@ -7,5 +7,5 @@
 msgstr ""
 "Project-Id-Version: 1\n"
-"POT-Creation-Date: 2016-01-01 12:00:00\n"
+"POT-Creation-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: Olivier Thauvin <olivier.thauvin@latmos.ipsl.fr\n"
@@ -17,18 +17,18 @@
 
 #. ($Dd)
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:106
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:92
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:50
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:64
 msgid "%1 days"
 msgstr "%1 jours"
 
 #. ($Dm)
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:105
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:91
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:49
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:63
 msgid "%1 months"
 msgstr "%1 mois"
 
 #. ($Dy)
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:104
-#: lib/LATMOS/Accounts/Web/Controller/Root.pm:90
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:48
+#: lib/LATMOS/Accounts/Web/Controller/About.pm:62
 msgid "%1 years"
 msgstr "%1 ans"
@@ -41,4 +41,8 @@
 msgid "(none)"
 msgstr "(sans)"
+
+#: root/html/includes/sidebar.tt:77
+msgid "About"
+msgstr "Ã propos"
 
 #: lib/LATMOS/Accounts/Web/Controller/Json/Timeline.pm:128
@@ -154,15 +158,15 @@
 
 #. (c.model("Accounts").db.get_object("user", c.user.username))
-#: root/html/index.tt:1
+#: root/html/about/index.tt:3
 msgid "Welcome %1."
 msgstr "Bienvenue %1."
 
 #. (c.stash.accountExists)
-#: root/html/index.tt:3
+#: root/html/about/index.tt:5
 msgid "Your account exists for %1, we hope it does not end too soon."
 msgstr "Votre compte existe depuis %1, nous espÃ©rons qu'il durera longtemps"
 
 #. (accountExpire)
-#: root/html/index.tt:7
+#: root/html/about/index.tt:9
 msgid "Your account will expire in %1, we are really sorry about this"
 msgstr "Votre compte exprirera dans %1, Nous vraiment dÃ©solÃ©."
Index: /trunk/LATMOS-Accounts-Web/root/html/about/index.tt
===================================================================
--- /trunk/LATMOS-Accounts-Web/root/html/about/index.tt	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/root/html/about/index.tt	(revision 1692)
@@ -1,3 +1,13 @@
 <div class="objectform">
+
+<p>[% l('Welcome [_1].',  c.model('Accounts').db.get_object('user', c.user.username )) | html %]</p>
+
+<p>[% l('Your account exists for [_1], we hope it does not end too soon.',
+    c.stash.accountExists) %]</p>
+
+[% IF accountExpire %]
+<p>[% l('Your account will expire in [_1], we are really sorry about this', accountExpire) %]
+[% END %]
+
 <h2>LATMOS::Accounts::Web</h2>
 
@@ -12,2 +22,4 @@
 <p>Philippe Weill, Yann Delcambre</p>
 </div>
+
+
Index: /trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt
===================================================================
--- /trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/root/html/includes/sidebar.tt	(revision 1692)
@@ -73,6 +73,7 @@
 </li>
 
-<li><a href="[% c.uri_for('/admin')
-%]">Gestion...</a></li>
+<li><a href="[% c.uri_for('/admin') %]">Gestion...</a></li>
+<li><a href="[% c.uri_for('/about') %]">
+    [% l('About') %]</a></li>
 </ul>
 
Index: /trunk/LATMOS-Accounts-Web/root/html/index.tt
===================================================================
--- /trunk/LATMOS-Accounts-Web/root/html/index.tt	(revision 1691)
+++ /trunk/LATMOS-Accounts-Web/root/html/index.tt	(revision 1692)
@@ -1,10 +1,1 @@
-<p>[% l('Welcome [_1].',  c.model('Accounts').db.get_object('user', c.user.username )) | html %]</p>
 
-<p>[% l('Your account exists for [_1], we hope it does not end too soon.',
-    c.stash.accountExists) %]</p>
-
-[% IF accountExpire %]
-<p>[% l('Your account will expire in [_1], we are really sorry about this', accountExpire) %]
-[% END %]
-
-